package com.sun.corba.se.spi.activation;

import org.omg.CORBA.BAD_OPERATION;
import org.omg.CORBA.CompletionStatus;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.portable.ResponseHandler;
import org.omg.CORBA.portable.InputStream;
import java.util.Hashtable;
import org.omg.CORBA.portable.InvokeHandler;
import org.omg.CORBA.portable.ObjectImpl;

public abstract class _ServerImplBase extends ObjectImpl implements Server, InvokeHandler
{
    private static Hashtable _methods;
    private static String[] __ids;
    
    public _ServerImplBase() {
    }
    
    public OutputStream _invoke(String key, InputStream inputStream, ResponseHandler responseHandler) {
        Integer n = (Integer)_ServerImplBase._methods.get(key);
        if (n == null) {
            throw new BAD_OPERATION(0, CompletionStatus.COMPLETED_MAYBE);
        }
        OutputStream outputStream;
        switch ((int)n) {
            case 0: {
                this.shutdown();
                outputStream = responseHandler.createReply();
                break;
            }
            case 1: {
                this.install();
                outputStream = responseHandler.createReply();
                break;
            }
            case 2: {
                this.uninstall();
                outputStream = responseHandler.createReply();
                break;
            }
            default: {
                throw new BAD_OPERATION(0, CompletionStatus.COMPLETED_MAYBE);
            }
        }
        return outputStream;
    }
    
    public String[] _ids() {
        return (String[])(String[])_ServerImplBase.__ids.clone();
    }
    
    static {
        (_ServerImplBase._methods = new Hashtable()).put("shutdown", new Integer(0));
        _ServerImplBase._methods.put("install", new Integer(1));
        _ServerImplBase._methods.put("uninstall", new Integer(2));
        _ServerImplBase.__ids = new String[] { "IDL:activation/Server:1.0" };
    }
}
